CC = gcc
CXX = g++
CFLAGS = -std=gnu11 -pedantic -Wall -Wextra -O2
CXXFLAGS = -pedantic -Wall -Wextra -Wno-error=unused-variable -O2 -std=c++11

OBJECTS = random_probing_server.o random_probing_client.o csi.o  \
	process_payload.o connections.o csi_measure.o ringbuffer.o transceive.o \
	daemon.o parameter_estimator.o time_calc.o simple_probing.o measure_common.o \
	message.o ping_pong_probing_client.o ping_pong_probing_server.o server.o# sha3.o

SERVER_OBJECTS = random_probing_server.o csi.o process_payload.o \
	connections.o csi_measure.o daemon.o parameter_estimator.o time_calc.o \
	secresketch.o bch_codec.o

CLIENT_OBJECTS = random_probing_client.o csi.o process_payload.o \
	connections.o csi_measure.o daemon.o parameter_estimator.o time_calc.o \
	secresketch.o bch_codec.o

MEASURE_SERVER_OBJ = ping_pong_probing_server.o measure_common.o transceive.o \
	csi.o ringbuffer.o message.o process_payload.o connections.o time_calc.o

MEASURE_CLIENT_OBJ = ping_pong_probing_client.o measure_common.o transceive.o \
	csi.o ringbuffer.o message.o process_payload.o connections.o time_calc.o
	
SIMPLE_PROBING_OBJ = simple_probing.o csi.o connections.o daemon.o \
	time_calc.o process_payload.o parameter_estimator.o server.o

all: random_probing_server random_probing_client ping_pong_probing_server ping_pong_probing_client simple_probing# sha3
	
random_probing_server: $(SERVER_OBJECTS)
	$(CC) -o random_probing_server $(SERVER_OBJECTS) $(CFLAGS) -lm -lstdc++

random_probing_client: $(CLIENT_OBJECTS)
	$(CC) -o random_probing_client $(CLIENT_OBJECTS) $(CFLAGS) -lm -lstdc++
	
bch_codec.o: ../keygen/bch_codec.h
	$(CC) -c $(CFLAGS) ../keygen/bch_codec.c
    
secresketch.o: ../keygen/secresketch.h
	$(CC) -c $(CFLAGS) ../keygen/secresketch.c
		
ping_pong_probing_server: $(MEASURE_SERVER_OBJ)
	$(CC) -o ping_pong_probing_server $(MEASURE_SERVER_OBJ) $(CFLAGS) -lm

ping_pong_probing_client: $(MEASURE_CLIENT_OBJ)
	$(CC) -o ping_pong_probing_client $(MEASURE_CLIENT_OBJ) $(CFLAGS) -lm

#sha3: $(OBJECTS)
#	$(CC) -o sha3 $(OBJECTS) $(CFLAGS) -lm
	
simple_probing: $(SIMPLE_PROBING_OBJ)
	$(CC) -o simple_probing $(SIMPLE_PROBING_OBJ) $(CFLAGS) -lm -lstdc++

ping_pong_probing_server.o: measure_common.h
ping_pong_probing_client.o: measure_common.h
random_probing_server.o: csi_measure.h
random_probing_client.o: csi_measure.h
simple_probing.o: csi_measure.h
csi_measure.o: csi_measure.h ../keygen/cpp/parameter_estimator.h
csi.o: csi.h
#sha3.o: sha3.h
measure_common.o: measure_common.h
process_payload.o: process_payload.h
connections.o: connections.h
server.o: ../utils/server.h ../utils/print.h ../utils/transceive.h
	$(CC) -c $(CFLAGS) ../utils/server.c ../utils/server.h ../utils/print.h ../utils/transceive.h

parameter_estimator.o: ../keygen/cpp/parameter_estimator.cpp ../keygen/cpp/parameter_estimator.h ../keygen/cpp/least-squares-cpp/include/lsqcpp.h
	$(CXX) -c $(CXXFLAGS) -I../keygen/cpp/least-squares-cpp/include/ -I../keygen/cpp/eigen/ ../keygen/cpp/parameter_estimator.cpp

transceive.o: ../utils/transceive.c ../utils/transceive.h
	$(CC) -c $(CFLAGS) ../utils/transceive.c
ringbuffer.o: ../utils/ringbuffer.c ../utils/ringbuffer.h
	$(CC) -c $(CFLAGS) ../utils/ringbuffer.c
message.o: ../utils/message.c ../utils/message.h
	$(CC) -c $(CFLAGS) ../utils/message.c
daemon.o: ../utils/daemon.c ../utils/daemon.h
	$(CC) -c $(CFLAGS) ../utils/daemon.c
time_calc.o: ../utils/time_calc.c ../utils/time_calc.h
	$(CC) -c $(CFLAGS) ../utils/time_calc.c

.PHONY: all clean
clean:
	rm -f random_probing_server random_probing_client ping_pong_probing_server ping_pong_probing_client simple_probing sha3 $(OBJECTS)
